#include "Asteroid.h"
#include "StateCore.h"

Asteroid::Asteroid(StateCore &core )
	:
	Entity( core )
{
}

void Asteroid::Move()
{	
	float speed = CalcSpeed( velocity);
	Coord slope = CalcAngleToSlope( angle );
	x = slope.x * speed;
	y = slope.y * speed;	
}

void Asteroid::Do()
{
	Move();
}

void Asteroid::DoCollision( Entity *ent )
{
	ReduceHealth(ent->GetDamage());
	ent->ReduceHealth(damage);
	ent->SetHitByAmmo(false);
}

void Asteroid::Draw(  ) const
{	
	core.gfx.DrawDisc(x, y, radius, core.gfx.FILLCOLOR_XRGB(255, 128, 0));
	
}

int Asteroid::GetAngle() const
{
	return angle;
}

// Big Asteroid class
BigAstro::BigAstro( StateCore &core)
	:
	Asteroid(core)
{
	Init( x, y);
}

void BigAstro::Init( int X,  int Y)
{	
	health = 10;
	radius = 50;
	scoreValue = 50;	
	x = X;
	y = Y;
	angle = (rand() % 180) + 90;
	damage = 3;
	wasHitByPlayerAmmo = false;	
}

// Small Asteroid class
SmallAstro::SmallAstro( StateCore &core)
	:
	Asteroid(core )
{
	Init(x, y);
}

void SmallAstro::Init( int X,  int Y)
{	
	health = 5;
	radius = 25;
	scoreValue = 25;	
	x = X;
	y = Y;
	angle = (rand() % 180) + 90;
	damage = 1.5;
	wasHitByPlayerAmmo = false;	
}

