#include "Button.h"

Button::Button()
{}

Button::Button(D3DGraphics::Color color, unsigned int x, unsigned int y, 
		unsigned int width, unsigned int height, std::string text)
		:
		X(x),
		Y(y),
		X2( x + width), 
		Y2( y + height ), 
		Text(text), 
		c(color)
		{}

bool Button::ButtonClicked(Input &user, D3DGraphics &gfx )
{
	unsigned int cX = user.GetMouseX();
	unsigned int cY = user.GetMouseY();
	
	c = gfx.FILLCOLOR_XRGB(255, 255, 255);
	if( (X < cX && cX < X2) && (Y < cY && cY < Y2 ))
	{
		c = gfx.FILLCOLOR_XRGB(255, 0, 255);
		if(user.LeftButtonClicked())
		{
			return true;
		}
	}

	return false;
}

const char*Button::GetText()const
{
	return Text.c_str();
}

void Button::Draw(D3DGraphics &gfx)
{
	gfx.DrawButton( X, Y, X2, Y2, Text.c_str(), &font, c);
}
