#include "Entity.h"
#include "TimerServer.h"
#include "StateCore.h"

Entity::Entity(StateCore &core)
	:
	core(core)
{
}

void Entity::Do()
{
}

float Entity::GetDamage( )
{	
	return damage;
}

unsigned int Entity::GetValue()
{
	return scoreValue;
}

bool Entity::CheckIsAlive( )
{
	return health > 0;
}

void Entity::SetPosition( unsigned int newx, unsigned int newy )
{
	x = newx;
	y = newy;
}

void Entity::UpdateTime( float *eventTimer)
{
	TimerClient tc;
	*eventTimer += tc.GetFrameTime();	
}

float Entity::GetHealth()
{
	return health;
}

void Entity::ReduceHealth( float health )
{
	this->health -= health;
}

void Entity::SetHitByAmmo( bool wasHit )
{
	hitByAmmo = wasHit;
}

bool Entity::GotHitByAmmo()
{
	return hitByAmmo;
}

float Entity::GetX() const
{
	return x;
}

float Entity::GetY() const
{
	return y;
}

unsigned int Entity::GetRadius() const
{
	return radius;
}

Entity::~Entity()
{}
