/******************************************************************************************
 *	Chili DirectX Framework Version 12.10.21											  *
 *	Game.h																				  *
 *	Copyright 2012 PlanetChili.net														  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#pragma once

#include <windows.h>
#include <time.h>

#include "D3DGraphics.h"
#include "Input.h"
#include "Sound.h"
#include "TimerServer.h"
#include "StateController.h"
#include "StateCore.h"

class Game
{
public:
	Game( HWND hWnd);
	~Game();
	void Go();

private:
	void ComposeFrame();
	/********************************/
	/*  User Functions              */
	void UpdateTimer();
	bool SwitchScreenMode();

	void DrawCursor();


	/********************************/
private:
	D3DGraphics gfx;
	Input user;
	DSound audio;
	/********************************/
	/*  User Variables              */
	StateCore core;
	StateController sc;
	/********************************/
};
