#include "GameOver.h"
#include "Button.h"
#include "Loading.h"

GameOver::GameOver(StateController &sc, StateCore &core)
:
GameState(sc, core)
{
	/*scoreboard.AddScore( "Fred", scoreboard.GetTime(), 15 );
	scoreboard.AddScore( "George", scoreboard.GetTime(), 50 );
	scoreboard.AddScore( "Alex", scoreboard.GetTime(), 3 );
	scoreboard.AddScore( "Luis", scoreboard.GetTime(), 42 );
	scoreboard.AddScore( "Josh", scoreboard.GetTime(), 43 );
	scoreboard.SaveScoreList();*/
}

void GameOver::Do()
{
	
	BeginFrame();
	Button mQuit;
	Button mTryAgain;
	if (mQuit.ButtonClicked(user, gfx))
	{

		core.cScore.SaveList();
		PostQuitMessage(0);
	}
	else if (mTryAgain.ButtonClicked(user, gfx))
	{
		sc.Transition(new Loading(sc, core));
	}
	ComposeFrame();

}

void GameOver::BeginFrame()
{
	gfx.BeginFrame();
}

void GameOver::ComposeFrame()
{
	gfx.DrawCircle(user.GetMouseX(), user.GetMouseY(), 32, gfx.FILLCOLOR_XRGB(255, 255, 255));
	gfx.DrawButton(SCREENWIDTH / 2 - 50, SCREENHEIGHT / 2 - 25, SCREENWIDTH / 2 + 50, SCREENHEIGHT / 2 + 25, "Quit", &f, gfx.FILLCOLOR_XRGB(255, 255, 255));
	gfx.DrawButton(SCREENWIDTH / 2 - 50, SCREENHEIGHT / 2 - 25, SCREENWIDTH / 2 + 50, SCREENHEIGHT / 2 + 25, "Try Again", &f, gfx.FILLCOLOR_XRGB(255, 255, 255));
}