#pragma once
#include <dinput.h>

#pragma comment (lib, "dinput8.lib")
#pragma comment(lib, "dxguid.lib")
class Input 
{
public:
	Input(HWND hWnd);
	~Input();

	void Poll();

	char ReadKey();
	bool PeekKey();
	
	short GetMouseX();
	short GetMouseY();
	bool BtnIsPressed( BYTE );
	bool LeftButtonClicked();

	short GetMouseWheel();
	char Read();
	bool Peek();
	void GetAxes( float* x, float* y );
	bool Firing();
	bool PauseGame();
	void SetClip( unsigned int sX, unsigned int sY);
	bool KeyIsPressed( unsigned char );
	bool KeyTyped( unsigned char key);
private:
	void RemoveDeadZone(float* axis);
	bool CheckJoystick();
	void ClipAxis( unsigned int maxClipSize, long* axis );
	float GetJoyX();
	float GetJoyY();
	float GetJoyZ();
	float GetJoyR();
	bool GetJoyButton(BYTE btn);

private:
	IDirectInput8 *lpdi;	

	LPDIRECTINPUTDEVICE8 pMouse;
	DIMOUSESTATE2 dims;
	DIPROPHEADER diProp;
		
	LPDIRECTINPUTDEVICE8 pKeyB;
	BYTE keys[256];

	LPDIRECTINPUTDEVICE8 pPad;
	DIDEVCAPS diCaps;
	DIJOYSTATE diJState;
	DIPROPDWORD dipdw;
	DIDEVICEOBJECTDATA* didod;

	long mX, mY;
	unsigned int clipWidth, clipHeight;
	HWND hwnd;
	bool CLF, plf;
};
