#include "Level.h"

Level::Level(D3DGraphics &gfx)
	:
	imgFile(),
	audFile(),
	currentTrigger( 1 ),
	aSpawn(0, 0),
	eBoss(0,0)
	
{
}

LPCTSTR Level::GetBGAud()
{
	return audFile;
}

LPCTSTR Level::GetBGImg()
{
	return imgFile;
}

unsigned int Level::GetNumEnemyTriggers()
{
	return numEnemySpawns;
}

Trigger *Level::GetTrigger( unsigned int index  )
{
	return triggerList[index];
}

unsigned int Level::GetCurrentTrigger()
{
	return currentTrigger;
}

unsigned int Level::GetLWidth() const
{
	return lWidth;
}

unsigned int Level::GetLHeight() const
{
	return lHeight;
}

Level::~Level()
{
	delete [] eSpawn;
}

Level1::Level1(D3DGraphics &gfx)
	:
	Level(gfx)
{
	numEnemySpawns = 4;
	
	imgFile = L"Images\\Level01.png";
	audFile = L"\\Audio\\Level01.wav";
	lHeight = 4200;
	lWidth = gfx.GetWidth();
	unsigned int temp = lHeight;
	unsigned int numTriggers = numEnemySpawns + 2;
	triggerList = new Trigger*[ numTriggers ];
	eSpawn = new Trigger(0, 0), sizeof(Trigger) *numEnemySpawns;
	unsigned int i = 0;
	for(i = 0; i < numEnemySpawns; i++)
	{
		unsigned int j = 3000 / numEnemySpawns * (i+1);
		eSpawn[ i ].Set( 0, temp - j);
		triggerList[ i ] = &eSpawn[i];
	}
	aSpawn.Set(rand() % 799, rand() % 2400 + 1200);
	triggerList[ i ] = &aSpawn;
	i++;
	eBoss.Set(399, 300);
	triggerList[ i ] = &eBoss;
}

Level2::Level2(D3DGraphics &gfx)
	:
	Level(gfx)
{
	numEnemySpawns = 4;
	
	imgFile = L"Images\\Level01.png";
	audFile = L"\\Audio\\Level01.wav";
	unsigned int temp = 4200;
	unsigned int numTriggers = numEnemySpawns + 2;
	triggerList = new Trigger*[ numTriggers ];
	eSpawn = new Trigger(0, 0), sizeof(Trigger) *numEnemySpawns;
	unsigned int i = 0;
	for(i = 0; i < numEnemySpawns; i++)
	{
		unsigned int j = 3000 / numEnemySpawns * (i+1);
		eSpawn[ i ].Set( 0, temp - j);
		triggerList[ i ] = &eSpawn[i];
	}
	aSpawn.Set(rand() % 799, rand() % 2400 + 1200);
	triggerList[ i ] = &aSpawn;
	i++;
	eBoss.Set(399, 300);
	triggerList[ i ] = &eBoss;
}

Level3::Level3(D3DGraphics &gfx)
	:
	Level(gfx)
{
	numEnemySpawns = 4;
	
	imgFile = L"Images\\Level01.png";
	audFile = L"\\Audio\\Level01.wav";
	unsigned int temp = 4200;
	unsigned int numTriggers = numEnemySpawns + 2;
	triggerList = new Trigger*[ numTriggers ];
	eSpawn = new Trigger(0, 0), sizeof(Trigger) *numEnemySpawns;
	unsigned int i = 0;
	for(i = 0; i < numEnemySpawns; i++)
	{
		unsigned int j = 3000 / numEnemySpawns * (i+1);
		eSpawn[ i ].Set( 0, temp - j);
		triggerList[ i ] = &eSpawn[i];
	}
	aSpawn.Set(rand() % 799, rand() % 2400 + 1200);
	triggerList[ i ] = &aSpawn;
	i++;
	eBoss.Set(399, 300);
	triggerList[ i ] = &eBoss;
}

Level4::Level4(D3DGraphics &gfx)
	:
	Level(gfx)
{
	numEnemySpawns = 4;
	
	imgFile = L"Images\\Level01.png";
	audFile = L"\\Audio\\Level01.wav";
	unsigned int temp = 4200;
	unsigned int numTriggers = numEnemySpawns + 2;
	triggerList = new Trigger*[ numTriggers ];
	eSpawn = new Trigger(0, 0), sizeof(Trigger) *numEnemySpawns;
	unsigned int i = 0;
	for(i = 0; i < numEnemySpawns; i++)
	{
		unsigned int j = 3000 / numEnemySpawns * (i+1);
		eSpawn[ i ].Set( 0, temp - j);
		triggerList[ i ] = &eSpawn[i];
	}
	aSpawn.Set(rand() % 799, rand() % 2400 + 1200);
	triggerList[ i ] = &aSpawn;
	i++;
	eBoss.Set(399, 300);
	triggerList[ i ] = &eBoss;
}

Level5::Level5(D3DGraphics &gfx)
	:
	Level(gfx)
{
	numEnemySpawns = 4;
	
	imgFile = L"Images\\Level01.png";
	audFile = L"\\Audio\\Level01.wav";
	unsigned int temp = 4200;
	unsigned int numTriggers = numEnemySpawns + 2;
	triggerList = new Trigger*[ numTriggers ];
	eSpawn = new Trigger(0, 0), sizeof(Trigger) *numEnemySpawns;
	unsigned int i = 0;
	for(i = 0; i < numEnemySpawns; i++)
	{
		unsigned int j = 3000 / numEnemySpawns * (i+1);
		eSpawn[ i ].Set( 0, temp - j);
		triggerList[ i ] = &eSpawn[i];
	}
	aSpawn.Set(rand() % 799, rand() % 2400 + 1200);
	triggerList[ i ] = &aSpawn;
	i++;
	eBoss.Set(399, 300);
	triggerList[ i ] = &eBoss;
}

Level6::Level6(D3DGraphics &gfx)
	:
	Level(gfx)
{
	numEnemySpawns = 4;
	
	imgFile = L"Images\\Level01.png";
	audFile = L"\\Audio\\Level01.wav";
	unsigned int temp = 4200;
	unsigned int numTriggers = numEnemySpawns + 2;
	triggerList = new Trigger*[ numTriggers ];
	eSpawn = new Trigger(0, 0), sizeof(Trigger) *numEnemySpawns;
	unsigned int i = 0;
	for(i = 0; i < numEnemySpawns; i++)
	{
		unsigned int j = 3000 / numEnemySpawns * (i+1);
		eSpawn[ i ].Set( 0, temp - j);
		triggerList[ i ] = &eSpawn[i];
	}
	aSpawn.Set(rand() % 799, rand() % 2400 + 1200);
	triggerList[ i ] = &aSpawn;
	i++;
	eBoss.Set(399, 300);
	triggerList[ i ] = &eBoss;
}

Level7::Level7(D3DGraphics &gfx)
	:
	Level(gfx)
{
	numEnemySpawns = 4;
	
	imgFile = L"Images\\Level01.png";
	audFile = L"\\Audio\\Level01.wav";
	unsigned int temp = 4200;
	unsigned int numTriggers = numEnemySpawns + 2;
	triggerList = new Trigger*[ numTriggers ];
	eSpawn = new Trigger(0, 0), sizeof(Trigger) *numEnemySpawns;
	unsigned int i = 0;
	for(i = 0; i < numEnemySpawns; i++)
	{
		unsigned int j = 3000 / numEnemySpawns * (i+1);
		eSpawn[ i ].Set( 0, temp - j);
		triggerList[ i ] = &eSpawn[i];
	}
	aSpawn.Set(rand() % 799, rand() % 2400 + 1200);
	triggerList[ i ] = &aSpawn;
	i++;
	eBoss.Set(399, 300);
	triggerList[ i ] = &eBoss;
}

Level8::Level8(D3DGraphics &gfx)
	:
	Level(gfx)
{
	numEnemySpawns = 4;
	
	imgFile = L"Images\\Level01.png";
	audFile = L"\\Audio\\Level01.wav";
	unsigned int temp = 4200;
	unsigned int numTriggers = numEnemySpawns + 2;
	triggerList = new Trigger*[ numTriggers ];
	eSpawn = new Trigger(0, 0), sizeof(Trigger) *numEnemySpawns;
	unsigned int i = 0;
	for(i = 0; i < numEnemySpawns; i++)
	{
		unsigned int j = 3000 / numEnemySpawns * (i+1);
		eSpawn[ i ].Set( 0, temp - j);
		triggerList[ i ] = &eSpawn[i];
	}
	aSpawn.Set(rand() % 799, rand() % 2400 + 1200);
	triggerList[ i ] = &aSpawn;
	i++;
	eBoss.Set(399, 300);
	triggerList[ i ] = &eBoss;
}