#include "Play.h"
#include "ScoreController.h"
#include "EntityController.h"

Play::Play(StateController &sc, StateCore &core)
:
GameState(sc, core),
ec(core),
player(&core.player),
cam(&core.cam)
{
	l = sc.GetLevel();	
}

void Play::BeginFrame()
{
	gfx.BeginFrame();
}

void Play::Do()
{
	/*
	Order of commands
	- Update camera position
	- Update player
		- Check Input for fire button pressed
		- Update player position
		- Update shield position
	- Check Triggers
		- Spawn entities using tirgger locations as spawn points and type
	- Update enemies
		- Update enemy position
		- Update player position with enemy
	- Update asteroids
		- Update position
	- Check for collision
		- Check distance between objects
		- Call entityies' DoCollision function if hit
			- Update health
	- Delete dead entities
		- Remove entities with health at or below 0
		- Update player score
			- Add to player score if enemy was killed by player ammo
	*/
	ec.Spawn();
	cam->Do();
	ec.Update(player);
	for (int i = 0; i < core.enemy.size(); i++)
	{
		ec.Update(core.enemy[i]);
		ec.CheckCollision(player, core.enemy[i]);
		for (int j = 0; j < core.ammo.size(); j++)
		{
			ec.CheckCollision(core.ammo[j], core.enemy[i]);
		}
		for (int j = 0; j < core.asteroid.size(); j++)
		{
			ec.CheckCollision(core.asteroid[j], core.enemy[i]);
		}
		if (ec.Kill(core.enemy[i]))
		{
			if (core.enemy[i]->GotHitByAmmo())
			{

			}
			core.enemy.erase(core.enemy.begin() + i);
		}
	}
	for (int i = 0; i < core.asteroid.size(); i++)
	{
		ec.Update(core.asteroid[i]);
		ec.CheckCollision(&core.player, core.asteroid[i]);
		for (int j = 0; j < core.ammo.size(); j++)
		{
			ec.CheckCollision(core.ammo[j], core.asteroid[i]);
		}
		for (int j = i + 1; j < core.asteroid.size(); j++)
		{
			ec.CheckCollision(core.asteroid[i], core.asteroid[j]);
		}
	}

	
	
	
	//CheckForTriggers();
	//p1Ship.Do(  );

	//// Enemy1 loop
	//for(unsigned int i = 0; i < enemies.size(); i++)
	//{
	//	enemies[ i ]->Do();
	//}

	//if(true)
	//{
	//	//boss->Do();
	//	//boss1.DoState( p1Ship.GetShipCenterX(), p1Ship.GetShipCenterY() );
	//	//B2Do();
	//}
	//// Asteroid loop
	//for( unsigned int index = 0; index < astros.size(); index++ )
	//{
	//	astros[ index ]->Do();
	//}
	//DetectCollision();
	//Kill();
}


void Play::ComposeFrame()
{
	core.player.Draw();
	char buffer[20];
	sprintf(buffer, "%d", core.cScore.GetPlayerScore());
	gfx.DrawString(buffer, 649, 8, &f, gfx.FILLCOLOR_XRGB(255, 255, 255));
}
