#include "Shield.h"
#include "TimerServer.h"
#include "StateCore.h"

Shield::Shield(StateCore &core)
	:
	Entity(core),
	rechargeRate(1000),
	rechargeTimer(0),
	respawnMax(1.0f)
{
	health = 1.0f;
	damage = 0;
}

void Shield::SetRadius( float rad )
{
	radius = rad;
}

void Shield::Do( )
{
	UpdateTime( &rechargeTimer);
	SetPosition( x, y);
	RechargeShield();
}

void Shield::RechargeShield()
{
	if(health < 1.0f)
	{
		if(rechargeTimer <= rechargeRate)
		{
			rechargeTimer = 0;
			health += 0.01f;
		}
	}
}

void Shield::Draw(D3DGraphics &gfx) const
{
	if(health > 0.0f)
	{
		gfx.DrawShield(x, y, radius, health);
	}
}

