#include "StateController.h"
#include "Menu.h"
#include "Shop.h"
#include "WeaponController.h"
StateController::StateController(StateCore &core)
		:
	currentLevel( 1 ),
	core(core),
	state(nullptr)
	{}

void StateController::Transition( GameState *pNew)
{
	delete state;
	state = pNew;
}

void StateController::Do()
{
	if (core.user.PauseGame())
	{
		//D3DGraphics &gfx, Input &user, StateController &sc, bool isPaused
		Transition(new MainMenu(*this, core, true));
	}
	if (core.user.KeyTyped(DIK_F10))
	{
		WeaponController wc = WeaponController(core);
		Transition(new Shop(*this, core));		
	}
	if (state)
	{
		state->Do();
	}
	else
	{
		Transition(new MainMenu( *this, core, false));
	}
}

unsigned int StateController::GetCurrentLevel()const
{
	return currentLevel;
}

Level *StateController::GetLevel() const
{
	return level;
}
void StateController::SetLevel( Level *l )
{
	level = l;
}

StateController::~StateController()
{
	
}