#pragma once

#define nWeps 5
#define nRes 3
#define objMax nWeps + nRes
#define nUnlocks 5

#include "Projectiles.h"

class Weapon
{
	friend class WeaponController;
public:
	Weapon(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	virtual ~Weapon();
	void Fire( Coord pos );
protected:
	void UpdateTimer(float *eventType);

	const unsigned int nUpgrades;
	bool unlocked;
	bool have;
	std::string name;
	float angle[ 5 ];
	unsigned int curlevel, nextLevel;
	float fireRate, fireTimer;
	Projectile *projectileType;
	StateCore &core;
	// Weapon attributes
	Coord dummyPos;
	Coord dummySlope;

};

class LaserWeap : public Weapon
{
public:
	LaserWeap(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	~LaserWeap();
};

class MachineGun : public Weapon
{
public:
	MachineGun(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	~MachineGun();
};

class ECannon : public Weapon
{
public:
	ECannon(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	~ECannon();
};

class Blaster : public Weapon
{
public:
	Blaster(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	~Blaster();
};

class MLauncher : public Weapon
{
public:
	MLauncher(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);	
	~MLauncher();

private:
	int maxMissiles, missileCount;
};