#pragma once

#include <vector>
#include "Input.h"
#include "Calculations.h"
#include "Weapon.h"

class StateCore;

/* This class is to switch weapons and act as a bridge between the different states*/
class WeaponController
{
public:
	WeaponController(StateCore &core);
	~WeaponController();
	void Fire(Coord pos);
	void SwitchWeapon();
	void Give(bool isGetting, Weapon *wep);
	bool IsUnlocked(Weapon *wep);
	bool Has(Weapon *wep);
	unsigned int GetCurrentUpgrade(Weapon *wep);
	std::string GetName(Weapon *wep);
	
	Weapon *GetWeapon(unsigned int i);
	void Upgrade(Weapon *wep);
	void Downgrade(Weapon *wep);
	void Lock(Weapon *wep);
	void Unlock(Weapon *wep);
	int PurchasePrice(Weapon *wep);
	int SalePrice(Weapon *wep);

private:
	Weapon **weapon;
	Weapon *curWeapon;
	char hotkeys[ nUnlocks ];
	StateCore &core;

};
